﻿--[[
        Give Me Buff:
                Copyright 2009 by MERK, Mileg
                based on code by Mileg and Stephen Blaising
                
]]

GMBuff_ADDONNAME = "Give Me Buff";
GMBuff_MACRONAME = "GMBuff";

GMBuff_VERSION = "4.2.0";

CAMPF = "";
CAMPF2 = "";
NoCAMPF = 1;
GMBuff_Save = {};
local PRIMARYbuff;
local SECONDARYbuff;
local TERTIARYbuff;
local Realm;
local Player;

function GMBuff_OnLoad()
  this:RegisterEvent("PLAYER_LOGIN");
  this:RegisterEvent("VARIABLES_LOADED");
  this:RegisterEvent("BAG_UPDATE");

  SlashCmdList["GIVEMEBUFFCOMMAND"] = GMBuff_SlashHandler;
  SLASH_GIVEMEBUFFCOMMAND1 = "/givemebuff";
  SLASH_GIVEMEBUFFCOMMAND2 = "/gmbuff";
  SLASH_GIVEMEBUFFCOMMAND3 = "/gmb";
  
end

function GMBuff_OnEvent()
  if (event == "PLAYER_LOGIN") then
    if (GetMacroIndexByName(GMBuff_MACRONAME) == 0) then
      local numGenMacros, numCharMacros = GetNumMacros();
      if (numGenMacros < 36) then
        CreateMacro(GMBuff_MACRONAME, 766, "", nil, nil)
      else
        GMBuff_Print("You have 36 General Macros. Cannot add "..GMBuff_MACRONAME.."!");
      end
    end
    if (GetSpellInfo(CAMPFIRE)) then
      CAMPF = "[mod:ctrl] "..CAMPFIRE..";";
      CAMPF2 = "[] "..CAMPFIRE..";";
    else
      CAMPF = "";
      NoCAMPF = 820;
    end
    GMBuff_MakeArray();
    GMBuff_Go();
  elseif (event == "VARIABLES_LOADED") then
    GMBuff_InitVars();
  elseif (event == "BAG_UPDATE") then
    GMBuff_Go();
  end
end

function GMBuff_SlashHandler(msg)
  if (msg) then
    msg = string.lower(msg);
  end
  if (msg == "help") then
    GMBuff_Print(GMBuff_ADDONNAME.." |cff3399CCv"..GMBuff_VERSION.." ");
    GMBuff_Print("Type /macro to open macro list.");
    GMBuff_Print("Drag GMBuff macro to your action bar.");
    GMBuff_Print("Click to eat best buff food.");
    GMBuff_Print("Hold SHIFT and click to eat second best buff food.");
    GMBuff_Print("Hold CTRL and click to create \"Basic Campfire\".");
    GMBuff_Print("/gmb will display the current buff order.");
    GMBuff_Print("/gmb b1=[BUFFTYPE] will update the first buff used in sorting the GMBuff macro.");
    GMBuff_Print("/gmb b2=[BUFFTYPE] will update the second buff used in sorting the GMBuff macro.");
    GMBuff_Print("/gmb b3=[BUFFTYPE] will update the third buff used in sorting the GMBuff macro.");
    GMBuff_Print("Replace [BUFFTYPE] with the following:");
    GMBuff_Print("    agi for Agility");
    GMBuff_Print("    arm for Armor Penetration");
    GMBuff_Print("    atk for Attack Power");
    GMBuff_Print("    crt for Critical Strike Rating");
    GMBuff_Print("    exp for Expertise");
    GMBuff_Print("    has for Haste");
    GMBuff_Print("    hp5 for Health Per 5");
    GMBuff_Print("    hit for Hit Rating");
    GMBuff_Print("    int for Intellect");
    GMBuff_Print("    mp5 for Mana Per 5");
    GMBuff_Print("    oth for Other (miscellaneous)");
    GMBuff_Print("    res for Resistance");
    GMBuff_Print("    spl for Spell Power");
    GMBuff_Print("    spi for Spirit");
    GMBuff_Print("    sta for Stamina");
    GMBuff_Print("    str for Strength");
  elseif (msg == "") then
    GMBuff_Print("Buff Food Order");
    GMBuff_Print("First Choice: "..PRIMARYbuff);
    GMBuff_Print("Second Choice: "..SECONDARYbuff);
    GMBuff_Print("Third Choice: "..TERTIARYbuff);
  elseif (msg == "b1=agi") then
    PRIMARYbuff = "Agility";
    GMBuff_Print("Primary Buff set to Agility");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=agi") then
    SECONDARYbuff = "Agility";
    GMBuff_Print("Secondary Buff set to Agility");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=agi") then
    TERTIARYbuff = "Agility";
    GMBuff_Print("Tertiary Buff set to Agility");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=arm") then
    PRIMARYbuff = "Armor Penetration";
    GMBuff_Print("Primary Buff set to Armor Penetration");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=arm") then
    SECONDARYbuff = "Armor Penetration";
    GMBuff_Print("Secondary Buff set to Armor Penetration");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=arm") then
    TERTIARYbuff = "Armor Penetration";
    GMBuff_Print("Tertiary Buff set to Armor Penetration");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=atk") then
    PRIMARYbuff = "Attack Power";
    GMBuff_Print("Primary Buff set to Attack Power");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=atk") then
    SECONDARYbuff = "Attack Power";
    GMBuff_Print("Secondary Buff set to Attack Power");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=atk") then
    TERTIARYbuff = "Attack Power";
    GMBuff_Print("Tertiary Buff set to Attack Power");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=crt") then
    PRIMARYbuff = "Critical Strike Rating";
    GMBuff_Print("Primary Buff set to Critical Strike");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=crt") then
    SECONDARYbuff = "Critical Strike Rating";
    GMBuff_Print("Secondary Buff set to Critical Strike");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=crt") then
    TERTIARYbuff = "Critical Strike Rating";
    GMBuff_Print("Tertiary Buff set to Critical Strike");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=exp") then
    PRIMARYbuff = "Expertise";
    GMBuff_Print("Primary Buff set to Expertise");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=exp") then
    SECONDARYbuff = "Expertise";
    GMBuff_Print("Secondary Buff set to Expertise");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=exp") then
    TERTIARYbuff = "Expertise";
    GMBuff_Print("Tertiary Buff set to Expertise");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=has") then
    PRIMARYbuff = "Haste";
    GMBuff_Print("Primary Buff set to Haste");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=has") then
    SECONDARYbuff = "Haste";
    GMBuff_Print("Secondary Buff set to Haste");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=has") then
    TERTIARYbuff = "Haste";
    GMBuff_Print("Tertiary Buff set to Haste");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=hp5") then
    PRIMARYbuff = "Health Per 5";
    GMBuff_Print("Primary Buff set to Health per 5");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=hp5") then
    SECONDARYbuff = "Health Per 5";
    GMBuff_Print("Secondary Buff set to Health per 5");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=hp5") then
    TERTIARYbuff = "Health Per 5";
    GMBuff_Print("Tertiary Buff set to Health per 5");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=hit") then
    PRIMARYbuff = "Hit Rating";
    GMBuff_Print("Primary Buff set to Hit Rating");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=hit") then
    SECONDARYbuff = "Hit Rating";
    GMBuff_Print("Secondary Buff set to Hit Rating");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=hit") then
    TERTIARYbuff = "Hit Rating";
    GMBuff_Print("Tertiary Buff set to Hit Rating");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=int") then
    PRIMARYbuff = "Intellect";
    GMBuff_Print("Primary Buff set to Intellect");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=int") then
    SECONDARYbuff = "Intellect";
    GMBuff_Print("Secondary Buff set to Intellect");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=int") then
    TERTIARYbuff = "Intellect";
    GMBuff_Print("Tertiary Buff set to Intellect");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=mp5") then
    PRIMARYbuff = "Mana Per 5";
    GMBuff_Print("Primary Buff set to Mana per 5");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=mp5") then
    SECONDARYbuff = "Mana Per 5";
    GMBuff_Print("Secondary Buff set to Mana per 5");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=mp5") then
    TERTIARYbuff = "Mana Per 5";
    GMBuff_Print("Tertiary Buff set to Mana per 5");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=oth") then
    PRIMARYbuff = "Other";
    GMBuff_Print("Primary Buff set to Other");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=oth") then
    SECONDARYbuff = "Other";
    GMBuff_Print("Secondary Buff set to Other");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=oth") then
    TERTIARYbuff = "Other";
    GMBuff_Print("Tertiary Buff set to Other");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=res") then
    PRIMARYbuff = "Resistance";
    GMBuff_Print("Primary Buff set to Resistance");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=res") then
    SECONDARYbuff = "Resistance";
    GMBuff_Print("Secondary Buff set to Resistance");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=res") then
    TERTIARYbuff = "Resistance";
    GMBuff_Print("Tertiary Buff set to Resistance");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=spl") then
    PRIMARYbuff = "Spell Power";
    GMBuff_Print("Primary Buff set to Spell Power");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=spl") then
    SECONDARYbuff = "Spell Power";
    GMBuff_Print("Secondary Buff set to Spell Power");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=spl") then
    TERTIARYbuff = "Spell Power";
    GMBuff_Print("Tertiary Buff set to Spell Power");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=spi") then
    PRIMARYbuff = "Spirit";
    GMBuff_Print("Primary Buff set to Spirit");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=spi") then
    SECONDARYbuff = "Spirit";
    GMBuff_Print("Secondary Buff set to Spirit");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=spi") then
    TERTIARYbuff = "Spirit";
    GMBuff_Print("Tertiary Buff set to Spirit");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=sta") then
    PRIMARYbuff = "Stamina";
    GMBuff_Print("Primary Buff set to Stamina");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=sta") then
    SECONDARYbuff = "Stamina";
    GMBuff_Print("Secondary Buff set to Stamina");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=sta") then
    TERTIARYbuff = "Stamina";
    GMBuff_Print("Tertiary Buff set to Stamina");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  elseif (msg == "b1=str") then
    PRIMARYbuff = "Strength";
    GMBuff_Print("Primary Buff set to Strength");
    GMBuff_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
    GMBuff_Go();
  elseif (msg == "b2=str") then
    SECONDARYbuff = "Strength";
    GMBuff_Print("Secondary Buff set to Strength");
    GMBuff_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
    GMBuff_Go();
  elseif (msg == "b3=str") then
    TERTIARYbuff = "Strength";
    GMBuff_Print("Tertiary Buff set to Strength");
    GMBuff_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
    GMBuff_Go();
  end
end

function GMBuff_Print(msg)
  if ((msg) and (strlen(msg) > 0)) then
    if (DEFAULT_CHAT_FRAME) then
      DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 1, 0);
    end
  end
end

function GMBuff_InitVars()
  
  Player=UnitName("player");
  Realm=GetCVar("realmName");

  if GMBuff_Save[Realm] == nil then
    GMBuff_Save[Realm] = {}
  end

  if GMBuff_Save[Realm][Player] == nil then
    GMBuff_Save[Realm][Player] = {}
  end

  if (GMBuff_Save[Realm][Player].PRIMARYbuff == nil) then
    GMBuff_Save[Realm][Player].PRIMARYbuff = "Stamina";
    PRIMARYbuff = "Stamina";
  else
    PRIMARYbuff = GMBuff_Save[Realm][Player].PRIMARYbuff;
  end

  if (GMBuff_Save[Realm][Player].SECONDARYbuff == nil) then
    GMBuff_Save[Realm][Player].SECONDARYbuff = "Spirit";
    SECONDARYbuff = "Spirit";
  else
    SECONDARYbuff = GMBuff_Save[Realm][Player].SECONDARYbuff;
  end

  if (GMBuff_Save[Realm][Player].TERTIARYbuff == nil) then
    GMBuff_Save[Realm][Player].TERTIARYbuff = "Critical Strike Rating";
    TERTIARYbuff = "Critical Strike Rating";
  else
    TERTIARYbuff = GMBuff_Save[Realm][Player].TERTIARYbuff;
  end
end

function GMBuff_MakeArray()
  GMBuff_BuffFood = {
    --oth
    [142]   = { [1] = BUFF_OTH_ZAP,                     [2] = 55, [3] = OTH, [4] = NON },
    [141]   = { [1] = BUFF_OTH_FIRE,                    [2] = 35, [3] = OTH, [4] = NON },
    [140]   = { [1] = BUFF_OTH_RAND_2,                  [2] =  0, [3] = OTH, [4] = NON },
    [139]   = { [1] = BUFF_OTH_RAND,                    [2] =  0, [3] = OTH, [4] = NON },
    [138]   = { [1] = BUFF_OTH_SAD,                     [2] =  0, [3] = OTH, [4] = NON },
    [137]   = { [1] = BUFF_OTH_HAPPY_2,                 [2] =  0, [3] = OTH, [4] = NON },
    [136]   = { [1] = BUFF_OTH_HAPPY,                   [2] =  0, [3] = OTH, [4] = NON },
    [135]   = { [1] = BUFF_OTH_FISH,                    [2] =  0, [3] = OTH, [4] = NON },
    [134]   = { [1] = BUFF_OTH_BIS_15000_12960_TRK_BST, [2] = 70, [3] = OTH, [4] = NON },
    [133]   = { [1] = BUFF_OTH_15000_TRK_HUM,           [2] = 70, [3] = OTH, [4] = NON },
    [132]   = { [1] = BUFF_OTH_7500_FORTUNE,            [2] = 65, [3] = OTH, [4] = NON },
    --sta/mp5
    [131]   = { [1] = BUFF_BIS_15000_12960_STA_40_MP5_16, [2] = 70, [3] = STA, [4] = MP5 },
    [130]   = { [1] = BUFF_15000_STA_40_MP5_16,           [2] = 70, [3] = STA, [4] = MP5 },
    [129]   = { [1] = BUFF_BIS_15000_12960_STA_40_MP5_12, [2] = 70, [3] = STA, [4] = MP5 },
    --sta/spi
    [128]   = { [1] = BUFF_15000_STA_40_SPI_40, [2] = 70, [3] = STA, [4] = SPI },
    --arm/sta
    [127]   = { [1] = BUFF_15000_ARM_40_STA_40, [2] = 70, [3] = ARM, [4] = STA },
    --agi/sta
    [126]   = { [1] = BUFF_BIS_15000_12960_AGI_40_STA_40, [2] = 70, [3] = AGI, [4] = STA },
    --atk/sta
    [125]   = { [1] = BUFF_BIS_15000_12960_ATK_80_STA_40, [2] = 70, [3] = ATK, [4] = STA },
    [124]   = { [1] = BUFF_15000_ATK_80_STA_40,           [2] = 70, [3] = ATK, [4] = STA },
    [123]   = { [1] = BUFF_BIS_15000_12960_ATK_60_STA_40, [2] = 70, [3] = ATK, [4] = STA },
    --exp/sta
    [122]   = { [1] = BUFF_15000_EXP_40_STA_40, [2] = 70, [3] = EXP, [4] = STA },
    --str/sta
    [121]   = { [1] = BUFF_15000_STR_40_STA_40, [2] = 70, [3] = STR, [4] = STA },
    --hit/sta
    [120]   = { [1] = BUFF_BIS_15000_12960_HIT_40_STA_40, [2] = 70, [3] = HIT, [4] = STA },
    --spl/sta
    [119]   = { [1] = BUFF_BIS_15000_12960_SPL_46_STA_40, [2] = 70, [3] = SPL, [4] = STA },
    [118]   = { [1] = BUFF_15000_SPL_46_STA_40,           [2] = 70, [3] = SPL, [4] = STA },
    [117]   = { [1] = BUFF_BIS_15000_12960_SPL_35_STA_40, [2] = 70, [3] = SPL, [4] = STA },
    --has/sta
    [116]   = { [1] = BUFF_BIS_15000_12960_HAS_40_STA_40, [2] = 70, [3] = HAS, [4] = STA },
    [115]   = { [1] = BUFF_15000_HAS_40_STA_40,           [2] = 70, [3] = HAS, [4] = STA },
    [114]   = { [1] = BUFF_15000_HAS_30_STA_40,           [2] = 70, [3] = HAS, [4] = STA },
    --crt/sta
    [113]   = { [1] = BUFF_BIS_15000_12960_CRT_40_STA_40, [2] = 70, [3] = CRT, [4] = STA },
    [112]   = { [1] = BUFF_15000_CRT_40_STA_40,           [2] = 70, [3] = CRT, [4] = STA },
    [111]   = { [1] = BUFF_BIS_15000_12960_CRT_30_STA_40, [2] = 70, [3] = CRT, [4] = STA },
    [110]   = { [1] = BUFF_15000_CRT_30_STA_30_2,         [2] = 70, [3] = CRT, [4] = STA },
    [109]   = { [1] = BUFF_15000_CRT_30_STA_30,           [2] = 70, [3] = CRT, [4] = STA },
    --atk/sta
    [108]   = { [1] = BUFF_15000_ATK_60_STA_30, [2] = 70, [3] = ATK, [4] = STA },
    --spl/sta
    [107]   = { [1] = BUFF_BIS_15000_12960_SPL_35_STA_30,   [2] = 70, [3] = SPL, [4] = STA },
    [106]   = { [1] = BUFF_BIS_15000_12960_SPL_35_STA_30_2, [2] = 70, [3] = SPL, [4] = STA },
    --has/sta
    [105]   = { [1] = BUFF_15000_HAS_30_STA_30_2, [2] = 70, [3] = HAS, [4] = STA },
    [104]   = { [1] = BUFF_15000_HAS_30_STA_30,   [2] = 70, [3] = HAS, [4] = STA },
    --sta/mp5
    [103]   = { [1] = BUFF_15000_STA_30_MP5_12, [2] = 70, [3] = STA, [4] = MP5 },
    --sa/spi
    [102]   = { [1] = BUFF_13200_STA_25_SPI_25,  [2] = 75, [3] = STA, [4] = SPI },
    [101]   = { [1] = BUFF_7500_STA_30_SPI_20_2, [2] = 55, [3] = STA, [4] = SPI },
    [100]   = { [1] = BUFF_7500_STA_30_SPI_20,   [2] = 65, [3] = STA, [4] = SPI },
    --crt/spi
    [99]   = { [1] = BUFF_7200M_CRT_20_SPI_30, [2] = 65, [3] = CRT, [4] = SPI },
    --sta
    [98]   = { [1] = BUFF_4320_STA_25, [2] = 55, [3] = STA, [4] = NON },
    --atk/spi
    [97]   = { [1] = BUFF_4320_ATK_40_SPI_20, [2] = 55, [3] = ATK, [4] = SPI },
    --hit/spi
    [96]   = { [1] = BUFF_7500_HIT_20_SPI_20, [2] = 65, [3] = HIT, [4] = SPI },
    --spl/spi
    [95]   = { [1] = BUFF_7500_SPL_23_SPI_20_6, [2] = 55, [3] = SPL, [4] = SPI },
    [94]   = { [1] = BUFF_7500_SPL_23_SPI_20_5, [2] = 55, [3] = SPL, [4] = SPI },
    [93]   = { [1] = BUFF_7500_SPL_23_SPI_20_4, [2] = 55, [3] = SPL, [4] = SPI },
    [92]   = { [1] = BUFF_7500_SPL_23_SPI_20_3, [2] = 65, [3] = SPL, [4] = SPI },
    [91]   = { [1] = BUFF_7500_SPL_23_SPI_20_2, [2] = 65, [3] = SPL, [4] = SPI },
    [90]   = { [1] = BUFF_7500_SPL_23_SPI_20,   [2] = 55, [3] = SPL, [4] = SPI },
    --agi/spi
    [89]   = { [1] = BUFF_7500_AGI_20_SPI_20_3, [2] = 55, [3] = AGI, [4] = SPI },
    [88]   = { [1] = BUFF_7500_AGI_20_SPI_20_2, [2] = 65, [3] = AGI, [4] = SPI },
    [87]   = { [1] = BUFF_7500_AGI_20_SPI_20,   [2] = 55, [3] = AGI, [4] = SPI },
    --sta/spi
    [86]   = { [1] = BUFF_7500_STA_20_SPI_20_2, [2] = 55, [3] = STA, [4] = SPI },
    [85]   = { [1] = BUFF_7500_STA_20_SPI_20,   [2] = 55, [3] = STA, [4] = SPI },
    [84]   = { [1] = BUFF_7200M_STA_20_SPI_20,  [2] = 65, [3] = STA, [4] = SPI },
    [83]   = { [1] = BUFF_4320_STA_20_SPI_20_3, [2] = 55, [3] = STA, [4] = SPI },
    [82]   = { [1] = BUFF_4320_STA_20_SPI_20_2, [2] = 55, [3] = STA, [4] = SPI },
    [81]   = { [1] = BUFF_4320_STA_20_SPI_20,   [2] = 55, [3] = STA, [4] = SPI },
    --sta/mp5
    [80]   = { [1] = BUFF_4320_STA_20_MP5_8, [2] = 55, [3] = STA, [4] = MP5 },
    --str/spi
    [79]   = { [1] = BUFF_7500_STR_20_SPI_20_2, [2] = 55, [3] = STR, [4] = SPI },
    [78]   = { [1] = BUFF_7500_STR_20_SPI_20,   [2] = 65, [3] = STR, [4] = SPI },
    --sta/spi
    [77]   = { [1] = BUFF_6000_STA_15_SPI_15,   [2] = 55, [3] = STA, [4] = SPI },
    [76]   = { [1] = BUFF_1392_STA_12_SPI_12_6, [2] = 40, [3] = STA, [4] = SPI },
    [75]   = { [1] = BUFF_1392_STA_12_SPI_12_5, [2] = 35, [3] = STA, [4] = SPI },
    [74]   = { [1] = BUFF_1392_STA_12_SPI_12_4, [2] = 40, [3] = STA, [4] = SPI },
    [73]   = { [1] = BUFF_1392_STA_12_SPI_12_3, [2] = 40, [3] = STA, [4] = SPI },
    [72]   = { [1] = BUFF_1392_STA_12_SPI_12_2, [2] = 35, [3] = STA, [4] = SPI },
    [71]   = { [1] = BUFF_1392_STA_12_SPI_12, [2] = 40, [3] = STA, [4] = SPI },
    --sta
    [70]   = { [1] = BUFF_4320_STA_10_4, [2] = 35, [3] = STA, [4] = NON },
    [69]   = { [1] = BUFF_4320_STA_10_3, [2] = 55, [3] = STA, [4] = NON },
    [68]   = { [1] = BUFF_4320_STA_10_2, [2] = 55, [3] = STA, [4] = NON },
    [67]   = { [1] = BUFF_4320_STA_10,   [2] = 45, [3] = STA, [4] = NON },
    [66]   = { [1] = BUFF_874_STA_10,    [2] = 55, [3] = STA, [4] = NON },
    --spi
    [65]   = { [1] = BUFF_4320_SPI_10, [2] = 55, [3] = SPI, [4] = NON },
    [64]   = { [1] = BUFF_874_SPI_10,  [2] = 35, [3] = SPI, [4] = NON },
    --sta/spi
	[63]    = { [1] = BUFF_2per24_STA_SPI_3,  [2] =  0, [3] = STA, [4] = SPI },
    [62]   = { [1] = BUFF_874_STA_8_SPI_8_10, [2] = 20, [3] = STA, [4] = SPI },
    [61]   = { [1] = BUFF_874_STA_8_SPI_8_9,  [2] = 25, [3] = STA, [4] = SPI },
    [60]   = { [1] = BUFF_874_STA_8_SPI_8_8,  [2] = 25, [3] = STA, [4] = SPI },
    [59]   = { [1] = BUFF_874_STA_8_SPI_8_7,  [2] = 25, [3] = STA, [4] = SPI },
    [58]   = { [1] = BUFF_874_STA_8_SPI_8_6,  [2] = 25, [3] = STA, [4] = SPI },
    [57]   = { [1] = BUFF_874_STA_8_SPI_8_5,  [2] = 25, [3] = STA, [4] = SPI },
    [56]   = { [1] = BUFF_874_STA_8_SPI_8_4,  [2] = 20, [3] = STA, [4] = SPI },
    [55]   = { [1] = BUFF_874_STA_8_SPI_8_3,  [2] = 25, [3] = STA, [4] = SPI },
    [54]   = { [1] = BUFF_874_STA_8_SPI_8_2,  [2] = 25, [3] = STA, [4] = SPI },
    [53]   = { [1] = BUFF_874_STA_8_SPI_8,    [2] = 25, [3] = STA, [4] = SPI },
    [52]   = { [1] = BUFF_552_STA_6_SPI_6_12, [2] = 10, [3] = STA, [4] = SPI },
    [51]   = { [1] = BUFF_552_STA_6_SPI_6_11, [2] = 10, [3] = STA, [4] = SPI },
    [50]   = { [1] = BUFF_552_STA_6_SPI_6_10, [2] = 15, [3] = STA, [4] = SPI },
    [49]   = { [1] = BUFF_552_STA_6_SPI_6_9,  [2] = 15, [3] = STA, [4] = SPI },
    [48]   = { [1] = BUFF_552_STA_6_SPI_6_8,  [2] = 15, [3] = STA, [4] = SPI },
    [47]   = { [1] = BUFF_552_STA_6_SPI_6_7,  [2] = 15, [3] = STA, [4] = SPI },
    [46]   = { [1] = BUFF_552_STA_6_SPI_6_6,  [2] = 15, [3] = STA, [4] = SPI },
    [45]   = { [1] = BUFF_552_STA_6_SPI_6_5,  [2] = 15, [3] = STA, [4] = SPI },
    [44]   = { [1] = BUFF_552_STA_6_SPI_6_4,  [2] = 15, [3] = STA, [4] = SPI },
    [43]   = { [1] = BUFF_552_STA_6_SPI_6_3,  [2] = 15, [3] = STA, [4] = SPI },
    [42]   = { [1] = BUFF_552_STA_6_SPI_6_2,  [2] = 12, [3] = STA, [4] = SPI },
    [41]   = { [1] = BUFF_552_STA_6_SPI_6,    [2] = 15, [3] = STA, [4] = SPI },
    [40]   = { [1] = BUFF_243_STA_4_SPI_4_11, [2] =  5, [3] = STA, [4] = SPI },
    [39]   = { [1] = BUFF_243_STA_4_SPI_4_10, [2] =  5, [3] = STA, [4] = SPI },
    [38]   = { [1] = BUFF_243_STA_4_SPI_4_9,  [2] =  5, [3] = STA, [4] = SPI },
    [37]   = { [1] = BUFF_243_STA_4_SPI_4_8,  [2] =  5, [3] = STA, [4] = SPI },
    [36]   = { [1] = BUFF_243_STA_4_SPI_4_7,  [2] =  5, [3] = STA, [4] = SPI },
    [35]   = { [1] = BUFF_243_STA_4_SPI_4_6,  [2] =  5, [3] = STA, [4] = SPI },
    [34]   = { [1] = BUFF_243_STA_4_SPI_4_5,  [2] =  5, [3] = STA, [4] = SPI },
    [33]   = { [1] = BUFF_243_STA_4_SPI_4_4,  [2] =  5, [3] = STA, [4] = SPI },
    [32]   = { [1] = BUFF_243_STA_4_SPI_4_3,  [2] =  5, [3] = STA, [4] = SPI },
    [31]   = { [1] = BUFF_243_STA_4_SPI_4_2,  [2] =  5, [3] = STA, [4] = SPI },
    [30]   = { [1] = BUFF_243_STA_4_SPI_4,    [2] =  5, [3] = STA, [4] = SPI },
    [29]   = { [1] = BUFF_61_STA_2_SPI_2_15,  [2] =  0, [3] = STA, [4] = SPI },
    [28]   = { [1] = BUFF_61_STA_2_SPI_2_14,  [2] =  0, [3] = STA, [4] = SPI },
    [27]   = { [1] = BUFF_61_STA_2_SPI_2_13,  [2] =  0, [3] = STA, [4] = SPI },
    [26]   = { [1] = BUFF_61_STA_2_SPI_2_12,  [2] =  0, [3] = STA, [4] = SPI },
    [25]   = { [1] = BUFF_61_STA_2_SPI_2_11,  [2] =  0, [3] = STA, [4] = SPI },
    [24]   = { [1] = BUFF_61_STA_2_SPI_2_10,  [2] =  0, [3] = STA, [4] = SPI },
    [23]   = { [1] = BUFF_61_STA_2_SPI_2_9,   [2] =  0, [3] = STA, [4] = SPI },
    [22]   = { [1] = BUFF_61_STA_2_SPI_2_8,   [2] =  0, [3] = STA, [4] = SPI },
    [21]    = { [1] = BUFF_61_STA_2_SPI_2_7,  [2] =  0, [3] = STA, [4] = SPI },
    [20]    = { [1] = BUFF_61_STA_2_SPI_2_6,  [2] =  0, [3] = STA, [4] = SPI },
    [19]    = { [1] = BUFF_61_STA_2_SPI_2_5,  [2] =  0, [3] = STA, [4] = SPI },
    [18]    = { [1] = BUFF_61_STA_2_SPI_2_4,  [2] =  0, [3] = STA, [4] = SPI },
    [17]    = { [1] = BUFF_61_STA_2_SPI_2_3,  [2] =  0, [3] = STA, [4] = SPI },
    [16]    = { [1] = BUFF_61_STA_2_SPI_2_2,  [2] =  0, [3] = STA, [4] = SPI },
    [15]    = { [1] = BUFF_61_STA_2_SPI_2,    [2] =  0, [3] = STA, [4] = SPI },
	[14]    = { [1] = BUFF_2per24_STA_SPI_2,  [2] =  0, [3] = STA, [4] = SPI },
    [13]    = { [1] = BUFF_2per24_STA_SPI,    [2] =  0, [3] = STA, [4] = SPI },
    --str
    [12]   = { [1] = BUFF_2148_STR_20_2, [2] = 45, [3] = STR, [4] = NON },
    [11]   = { [1] = BUFF_2148_STR_20,   [2] = 55, [3] = STR, [4] = NON },
    [10]   = { [1] = BUFF_1933_STR_10,   [2] = 45, [3] = STR, [4] = NON },
    --spl
    [9]   = { [1] = BUFF_1933_SPL_14, [2] = 45, [3] = SPL, [4] = NON },
    --res
    [8]   = { [1] = BUFF_4320_RES_8, [2] = 55, [3] = RES, [4] = NON },
    --mp5
    [7]   = { [1] = BUFF_874_MP5_8,          [2] = 35, [3] = MP5, [4] = NON },
    [6]   = { [1] = BUFF_BIS_840_1260_MP5_6, [2] = 30, [3] = MP5, [4] = NON },
    [5]   = { [1] = BUFF_378_MP5_3,          [2] = 10, [3] = MP5, [4] = NON },
    --int
    [4]   = { [1] = BUFF_1933_INT_10, [2] = 45, [3] = INT, [4] = NON },
    --hp5
    [3]   = { [1] = BUFF_874_HP5_6, [2] = 35, [3] = HP5, [4] = NON },
    --atk
    [2]   = { [1] = BUFF_1933_ATK_24, [2] = 45, [3] = ATK, [4] = NON },
    --agi
    [1]   = { [1] = BUFF_874_AGI_10, [2] = 35, [3] = AGI, [4] = NON },
  }
end

function GMBuff_Go()
  
  local BuffBFoodRank = 0;
  local BBuffBFoodRank = 0;
  local BuffBFoodItemNum = 0;
  local BBuffBFoodItemNum = 0;
  local oldBFoodItemLink = "Nothing";
  local BoldBFoodItemLink = "Nothing";
  local exact = "no";
  local SECexact = "no";
  local TERexact = "no";
  local primary = "no";
  local secondary = "no";
  local tertiary = "no";

  for bagID = 0, 4, 1 do
    local bagSlotCnt = GetContainerNumSlots(bagID);
    if (bagSlotCnt > 0) then
      for slot = 1, bagSlotCnt, 1 do
        local itemLink = GetContainerItemLink(bagID, slot);
        local itemNumber = GMBuff_NumFromLink(itemLink);
        if (itemNumber) then
          for index = 1, table.getn(GMBuff_BuffFood), 1 do
            if (GMBuff_BuffFood[index][1] == itemNumber) then
              if (GMBuff_BuffFood[index][2] <= UnitLevel("player")) then
                if (((GMBuff_BuffFood[index][3] == PRIMARYbuff) and (GMBuff_BuffFood[index][4] == SECONDARYbuff)) or ((GMBuff_BuffFood[index][3] == SECONDARYbuff) and (GMBuff_BuffFood[index][4] == PRIMARYbuff))) then
                  if ((index > BuffBFoodRank) or (exact == "no")) then
                    BoldBFoodItemLink = oldBFoodItemLink;
                    oldBFoodItemLink = itemLink;
                    BBuffBFoodRank = BuffBFoodRank;
                    BuffBFoodRank = index;
                    BBuffBFoodItemNum = BuffBFoodItemNum;
                    BuffBFoodItemNum = itemNumber;
                    exact = "yes";
                  elseif (((index > BBuffBFoodRank) and (index < BuffBFoodRank)) or (BBuffBFoodItemNum == 0)) then
                    if (index ~= BuffBFoodRank) then
                      BoldBFoodItemLink = itemLink;
                      BBuffBFoodRank = index;
                      BBuffBFoodItemNum = itemNumber;
                    end
                  end
                elseif (((GMBuff_BuffFood[index][3] == PRIMARYbuff) and (GMBuff_BuffFood[index][4] == TERTIARYbuff)) or ((GMBuff_BuffFood[index][3] == TERTIARYbuff) and (GMBuff_BuffFood[index][4] == PRIMARYbuff))) then
                  if (((exact == "no") and (index > BuffBFoodRank)) or ((exact == "no") and (SECexact == "no"))) then
                    BBuffBFoodRank = BuffBFoodRank;
                    BuffBFoodRank = index;
                    BBuffBFoodItemNum = BuffBFoodItemNum;
                    BuffBFoodItemNum = itemNumber;
                    SECexact = "yes";
                  elseif (((exact == "no") and (index > BBuffBFoodRank)  and (index < BuffBFoodRank)) or (BBuffBFoodItemNum == 0)) then
                    if (index ~= BuffBFoodRank) then
                      BBuffBFoodRank = index;
                      BBuffBFoodItemNum = itemNumber;
                    end
                  end
                elseif (((GMBuff_BuffFood[index][3] == SECONDARYbuff) and (GMBuff_BuffFood[index][4] == TERTIARYbuff)) or ((GMBuff_BuffFood[index][3] == TERTIARYbuff) and (GMBuff_BuffFood[index][4] == SECONDARYbuff))) then
                  if (((exact == "no") and (SECexact == "no") and (index > BuffBFoodRank)) or ((exact == "no") and (SECexact == "no") and (TERexact == "no"))) then
                    BBuffBFoodRank = BuffBFoodRank;
                    BuffBFoodRank = index;
                    BBuffBFoodItemNum = BuffBFoodItemNum;
                    BuffBFoodItemNum = itemNumber;
                    TERexact = "yes";
                  elseif (((exact == "no") and (SECexact == "no") and (index > BBuffBFoodRank) and (index < BuffBFoodRank)) or (BBuffBFoodItemNum == 0)) then
                    if (index ~= BuffBFoodRank) then
                      BBuffBFoodRank = index;
                      BBuffBFoodItemNum = itemNumber;
                    end
                  end
                elseif (((GMBuff_BuffFood[index][3] == PRIMARYbuff) or (GMBuff_BuffFood[index][4] == PRIMARYbuff))) then
                  if (((exact == "no") and (SECexact == "no") and (TERexact == "no") and (index > BuffBFoodRank)) or ((exact == "no") and (SECexact == "no") and (TERexact == "no") and (primary == "no"))) then
                    BBuffBFoodRank = BuffBFoodRank;
                    BuffBFoodRank = index;
                    BBuffBFoodItemNum = BuffBFoodItemNum;
                    BuffBFoodItemNum = itemNumber;
                    primary = "yes";
                  elseif (((exact == "no") and (SECexact == "no") and (TERexact == "no") and (index > BBuffBFoodRank) and (index < BuffBFoodRank)) or (BBuffBFoodItemNum == 0)) then
                    if (index ~= BuffBFoodRank) then
                    BBuffBFoodRank = index;
                    BBuffBFoodItemNum = itemNumber;
                    end
                  end
                elseif (((GMBuff_BuffFood[index][3] == SECONDARYbuff) or (GMBuff_BuffFood[index][4] == SECONDARYbuff))) then
                  if (((exact == "no") and (SECexact == "no") and (TERexact == "no") and (primary == "no") and (index > BuffBFoodRank)) or ((exact == "no") and (SECexact == "no") and (TERexact == "no") and (primary == "no") and (secondary == "no"))) then
                    BBuffBFoodRank = BuffBFoodRank;
                    BuffBFoodRank = index;
                    BBuffBFoodItemNum = BuffBFoodItemNum;
                    BuffBFoodItemNum = itemNumber;
                    secondary = "yes";
                  elseif (((exact == "no") and (SECexact == "no") and (TERexact == "no") and (primary == "no") and (index > BBuffBFoodRank) and (index < BuffBFoodRank)) or (BBuffBFoodItemNum == 0)) then
                    if (index ~= BuffBFoodRank) then
                      BBuffBFoodRank = index;
                      BBuffBFoodItemNum = itemNumber;
                    end
                  end
                elseif (((GMBuff_BuffFood[index][3] == TERTIARYbuff) or (GMBuff_BuffFood[index][4] == TERTIARYbuff))) then
                  if (((exact == "no") and (SECexact == "no") and (TERexact == "no") and (primary == "no") and (secondary == "no") and (index > BuffBFoodRank)) or ((exact == "no") and (SECexact == "no") and (TERexact == "no") and (primary == "no") and (secondary == "no") and (tertiary == "no"))) then
                    BBuffBFoodRank = BuffBFoodRank;
                    BuffBFoodRank = index;
                    BBuffBFoodItemNum = BuffBFoodItemNum;
                    BuffBFoodItemNum = itemNumber;
                    tertiary = "yes";
                  elseif (((exact == "no") and (SECexact == "no") and (TERexact == "no") and (primary == "no") and (secondary == "no") and (index > BBuffBFoodRank) and (index < BuffBFoodRank)) or (BBuffBFoodItemNum == 0)) then
                    if (index ~= BuffBFoodRank) then
                      BBuffBFoodRank = index;
                      BBuffBFoodItemNum = itemNumber;
                    end
                  end
                end
              end
            end
          end
        end
      end
      if (BuffBFoodItemNum == 0) then
        for slot = 1, bagSlotCnt, 1 do
        local itemLink = GetContainerItemLink(bagID, slot);
        local itemNumber = GMBuff_NumFromLink(itemLink);
          if (itemNumber) then
            for index = 1, table.getn(GMBuff_BuffFood), 1 do
              if (GMBuff_BuffFood[index][1] == itemNumber) then
                if (GMBuff_BuffFood[index][2] <= UnitLevel("player")) then
                  if (index > BuffBFoodRank) then
                    BBuffBFoodRank = BuffBFoodRank;
                    BuffBFoodRank = index;
                    BBuffBFoodItemNum = BuffBFoodItemNum;
                    BuffBFoodItemNum = itemNumber;
                  elseif ((index > BBuffBFoodRank) and (index < BuffBFoodRank)) then
                    BBuffBFoodRank = index;
                    BBuffBFoodItemNum = itemNumber;
                  end
                end
              end
            end
          end
        end
      end
    end
  end
  
  if ((BuffBFoodRank > 0) and (BBuffBFoodRank > 0)) then
    EditMacro(GMBuff_MACRONAME, GMBuff_MACRONAME, 1, "#showtooltip\n/use "..CAMPF.." [mod:shift] item:"..BBuffBFoodItemNum.."; [] item:"..BuffBFoodItemNum, nil, nil);
  elseif ((BuffBFoodRank > 0) and (BBuffBFoodRank == 0)) then
    EditMacro(GMBuff_MACRONAME, GMBuff_MACRONAME, 1, "#showtooltip\n/use "..CAMPF.." [] item:"..BuffBFoodItemNum, nil, nil);
  elseif (BuffBFoodRank == 0) then
    EditMacro(GMBuff_MACRONAME, GMBuff_MACRONAME, NoCAMPF, "#showtooltip\n/use "..CAMPF2, nil, nil);
  end
end

function GMBuff_NumFromLink(itemLink)
  if (not itemLink) then
    return nil;
  end
  local _, _, itemNumber = strfind(itemLink, "item:(%d+):");
  return itemNumber;
end
