﻿-- Give Me Mana
-- Version | English (by MERK)
-- Last Update | 01/17/2009

--Spells & Tradeskills
ALCH                    ="Alchemy";
CONJW                   ="Conjure Water";
CONJR                   ="Conjure Refreshment";

--Zones
  --Battleground
WSG                     ="Warsong Gulch";
AB                      ="Arathi Basin";
AV                      ="Alterac Valley";
EOTS                    ="Eye of the Storm";
SOTA                    ="Strand of the Ancients";
  --Instance
ARCA                    ="The Arcatraz";
EYE                     ="The Eye";
BOT                     ="The Botanica";
MECH                    ="The Mechanar";
SSC                     ="Serpentshrine Cavern";
UB                      ="The Underbog";
SV                      ="The Steamvault";
SP                      ="The Slave Pens";
GL                      ="Gruul's Lair";
  --Normal
BEM                     ="Blade's Edge Mountains";
  --Arena
ARENA_BE                ="Blade's Edge Arena";
ARENA_D                 ="Dalaran Arena";
ARENA_N                 ="Nagrand Arena";
ARENA_ROL               ="Ruins of Lordaeron";
ARENA_ROV               ="The Ring of Valor";

if ( GetLocale() == "deDE" ) then
-- Version | German (by MERK, special thanks to Mightymagic)
-- Last Update | 02/03/2009

--Spells & Tradeskills
ALCH                    ="Alchimie";
CONJW                   ="Wasser herbeizaubern";
CONJR                   ="Erfrischungen herbeizaubern";

--Zones
  --Battleground
WSG                     ="Kriegshymnenschlucht";
AB                      ="Arathibecken";
AV                      ="Alteractal";
EOTS                    ="Auge des Sturms";
SOTA                    ="Strand der Uralten";
  --Instance
ARCA                    ="Die Arkatraz";
EYE                     ="Das Auge";
BOT                     ="Die Botanika";
MECH                    ="Die Mechanar";
SSC                     ="H穬e des Schlangenschreins";
UB                      ="Der Tiefensumpf";
SV                      ="Die Dampfkammer";
SP                      ="Die Sklavenunterkte";
GL                      ="Gruuls Unterschlupf";
  --Normal
BEM                     ="Schergrat";
  --Arena
ARENA_BE                ="Arena des Schergrats";
ARENA_D                 ="Arena von Dalaran";
ARENA_N                 ="Arena von Nagrand";
ARENA_ROL               ="Ruinen von Lordaeron";
ARENA_ROV               ="Der Ring der Ehre";

end

if ( GetLocale() == "frFR" ) then
-- Version | French (by MERK)
-- Last Update | 02/03/2009

--Spells & Tradeskills
ALCH                    ="Alchimie";
CONJW                   ="Invocation d'eau";
CONJR                   ="Invocation de rafraîchissements";

--Zones
  --Battleground
WSG                     ="Goulet des Chanteguerres";
AB                      ="Bassin d'Arathi";
AV                      ="Vallꥠd'Alterac";
EOTS                    ="L'ͩl du cyclone";
SOTA                    ="Rivage des Anciens";
  --Instance
ARCA                    ="L'Arcatraz";
EYE                     ="L'Oeil";
BOT                     ="La Botanica";
MECH                    ="Le Mꤨanar";
SSC                     ="Caverne du sanctuaire du Serpent";
UB                      ="La Basse-tourbi鳥";
SV                      ="Le Caveau de la vapeur";
SP                      ="Les enclos aux esclaves";
GL                      ="Repaire de Gruul";
  --Normal
BEM                     ="Les Tranchantes";
  --Arena
ARENA_BE                ="Ar鯥 des Tranchantes";
ARENA_D                 ="Ar鯥 de Dalaran";
ARENA_N                 ="Ar鯥 de Nagrand";
ARENA_ROL               ="Ruines de Lordaeron";
ARENA_ROV               ="L'Ar鯥 des valeureux";

end

if ( GetLocale() == "esES" ) then
-- Version | Spanish (by Mileg, updated by MERK)
-- Last Update | 02/03/2009

--Spells & Tradeskills
ALCH                    ="Alquimia";
CONJW                   ="Crear agua";
CONJR                   ="Crear refrigerio";

--Zones
  --Battleground
WSG                     ="Garganta Grito de Guerra";
AB                      ="Cuenca de Arathi";
AV                      ="Valle de Alterac";
EOTS                    ="Ojo de la Tormenta";
SOTA                    ="Playa de los Ancestros";
  --Instance
ARCA                    ="El Arcatraz";
EYE                     ="El Ojo";
BOT                     ="El Invern⤵lo";
MECH                    ="El Mechanar";
SSC                     ="Caverna Santuario Serpiente";
UB                      ="La Sotiꯡga";
SV                      ="La C⮡ra de Vapor";
SP                      ="Recinto de los Esclavos";
GL                      ="Guarida de Gruul";
  --Normal
BEM                     ="Monta⢳ Filospada";
  --Arena
ARENA_BE                ="Arena Filospada";
ARENA_D                 ="Arena de Dalaran";
ARENA_N                 ="Arena de Nagrand";
ARENA_ROL               ="Ruinas de Lordaeron";
ARENA_ROV               ="El Culo del Valor";

end

if ( GetLocale() == "zhTW" ) then 
-- Version | Traditional Chinese (by Saqucka)
-- Last Update | 02/03/2009

--Spells & Tradeskills
ALCH                    ="鍊金術"; 
CONJW                   ="造水術"; 
CONJR                   ="召喚餐點"; 
--Zones
  --Battleground
WSG                     ="戰歌峽谷"; 
AB                      ="阿拉希盆地"; 
AV                      ="奧特蘭克山谷"; 
EOTS                    ="暴風之眼"; 
SOTA                    ="遠祖灘頭"; 
  --Instance
ARCA                    ="亞克崔茲"; 
EYE                     ="風暴要塞"; 
BOT                     ="波塔尼卡"; 
MECH                    ="麥克納爾"; 
SSC                     ="毒蛇神殿洞穴"; 
UB                      ="深幽泥沼"; 
SV                      ="蒸汽洞窟"; 
SP                      ="奴隸監獄"; 
GL                      ="戈魯爾之巢"; 
  --Normal
BEM                     ="劍刃山脈"; 
  --Arena
ARENA_BE                ="劍刃競技場"; 
ARENA_D                 ="達拉然下水道"; 
ARENA_N                 ="納葛蘭競技場"; 
ARENA_ROL               ="羅德隆廢墟"; 
ARENA_ROV               ="勇武之環"; 

end
