﻿--[[
        Give Me Mount:
                copyright 2008-2009 by MERK, Mileg
                based on code by Mileg and Stephen Blaising

]]        

GMMount_ADDONNAME = "Give Me Mount";
GMMount_MACRONAME = "GMMount";

GMMount_VERSION = "4.2.0";

GSTWLF = "";
GSTWLF2 = "";
NoGSTWLF = "";
GMMount_ZoneName = "Default";
GMMount_SubZoneName = "Default";
GMMount_Flyable = ""; 
spellName = "";
GMMount_Mounts = {};
creatureName = ""
RidingLevel = 0

local GndRandNum = 0;
local RndNumCnt = 2;
local FlyRandNum = 0;
local FRndNumCnt = 2;
local GROUNDMOUNT = "";
local FLYINGMOUNT = "";
local LastGND = "";
local LastFLY = "";
local DisLastGND = "";
local DisLastFLY = "";

MOUNTEDUP = nil;

function GMMount_OnLoad()
  this:RegisterEvent("PLAYER_LOGIN");
--  this:RegisterEvent("PLAYER_REGEN_ENABLED");

  SlashCmdList["GIVEMEMOUNTCOMMAND"] = GMMount_SlashHandler;
  SLASH_GIVEMEMOUNTCOMMAND1 = "/givememount";
  SLASH_GIVEMEMOUNTCOMMAND2 = "/gmmount";
  SLASH_GIVEMEMOUNTCOMMAND3 = "/gmmt";
  
end

function GMMount_OnEvent()
  if (event == "PLAYER_LOGIN") then
    if (GetMacroIndexByName(GMMount_MACRONAME) == 0 ) then
      local numGenMacros, numCharMacros = GetNumMacros();
      if (numGenMacros < 36) then
        CreateMacro(GMMount_MACRONAME, 27, "", nil, nil);
      else
        GMMana_Print("You have 36 General Macros. Cannot add "..GMMana_MACRONAME.."!");
      end
    end
    if (GetSpellInfo(GHOSTWLF)) then
      GSTWLF = "[combat,button:1] "..GHOSTWLF.."; [mod:ctrl,button:1] "..GHOSTWLF..";";
      GSTWLF2 = " "..GHOSTWLF;
    else
      GSTWLF = "";
      NoGSTWLF = 27;
    end
    spellName = GetSpellInfo(GM_CWF);
    GMMount_MakeArray();
    GMMount_Go();
--  elseif (event == "PLAYER_REGEN_ENABLED") then
--    GMMount_Go();
  end
end

function GMMount_OnUpdate()

  if (GMMount_SubZoneName ~= GetSubZoneText()) and (not IsMounted()) then

    for skillIndex = 1, GetNumSkillLines() do
      array = {GetSkillLineInfo(skillIndex)}
      if (array[1] == "Riding") then
	--GMMount_Print("Found " ..array[1].. " with skill: " ..array[4])
	RidingLevel = array[4]
      end
      
      GMMount_Go();
    end
  
  end
  
  if (IsMounted() ~= MOUNTEDUP) then
    if IsMounted() then
      MOUNTEDUP = IsMounted();
      GMMount_Go();
    else
      MOUNTEDUP = IsMounted();
      GMMount_Go();
    end
  end
end

function GMMount_SlashHandler(msg)
  if (msg) then
    msg = string.lower(msg);
  end
  if (msg == "help" or msg == "") then
    GMMount_Print(GMMount_ADDONNAME.." |cff3399CCv"..GMMount_VERSION.." ");
    GMMount_Print("Type /macro to open macro list.");
    GMMount_Print("Drag GMMount macro to your action bar.");
    GMMount_Print("This macro has multiple purposes and changes based on location.");
    GMMount_Print("Click to summon mount showing on icon.");
    GMMount_Print("Hold SHIFT and click to summon ground mount if flying is showing.");
    GMMount_Print("While mounted right click to dismount (will dismount even if flying).");
    GMMount_Print("Shamans can hold CTRL and click to cast \"Ghost Wolf\".");
    GMMount_Print("During combat Shamans can click to cast \"Ghost Wolf\".");
  elseif (msg == "update") then
    GMMount_Go();
  end
end

function GMMount_GetZoneType()
  if (GMMount_ZoneName ~= GetZoneText()) then
    GMMount_ZoneName = GetZoneText();
--    --GMMount_Print("|cff3399CCUpdated Zone");
  elseif (GMMount_SubZoneName ~= GetSubZoneText()) then
    GMMount_SubZoneName = GetSubZoneText();
--    --GMMount_Print("|cff3399CCUpdated Zone");
  end
  if (GMMount_ZoneName == TOAQ) then
    GMMount_Flyable = "AQ";
  elseif ((GMMount_ZoneName == CWNR1 or GMMount_ZoneName == CWNR2 or GMMount_ZoneName == CWNR3 or GMMount_ZoneName == CWNR4 or GMMount_ZoneName == CWNR5 or GMMount_ZoneName == CWNR6 or GMMount_ZoneName == CWNR7 or GMMount_ZoneName == CWNR8 or  GMMount_ZoneName == CWNR9 or GMMount_ZoneName == CWNR10 or GMMount_ZoneName == CWNR11) and (spellName ~= GM_CWF)) then
    GMMount_Flyable = "NO";
  elseif (((IsFlyableArea()) and (GMMount_ZoneName ~= CWNR3) and (GMMount_ZoneName ~= CWNR10) and (GMMount_ZoneName ~= UNGOCR)) or ((IsFlyableArea()) and (GMMount_SubZoneName == KRASUS))) then
    GMMount_Flyable = "YES";
  else
    GMMount_Flyable = "NO";
  end
end

function GMMount_Print(msg) 
  if ((msg) and (strlen(msg) > 0)) then
    if (DEFAULT_CHAT_FRAME) then
      DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 1, 0);
    end
  end
end

function GMMount_MakeArray()
  GMMount_Mounts = {
     [206] = { [1] = AQ_MOUNT5,   [2] = "AQ",  [3] = "AQ"   },
     [205] = { [1] = AQ_MOUNT4,   [2] = "AQ",  [3] = "AQ"   },
     [204] = { [1] = AQ_MOUNT3,   [2] = "AQ",  [3] = "AQ"   },
     [203] = { [1] = AQ_MOUNT2,   [2] = "AQ",  [3] = "AQ"   },
     [202] = { [1] = AQ_MOUNT1,   [2] = "AQ",  [3] = "AQ"   },
     [201] = { [1] = X_MOUNT8,    [2] = "YES", [3] = "EXTR" },
     [200] = { [1] = X_MOUNT7,    [2] = "YES", [3] = "EXTR" },
     [199] = { [1] = X_MOUNT6,    [2] = "YES", [3] = "EXTR" },
     [198] = { [1] = X_MOUNT5,    [2] = "YES", [3] = "EXTR" },
     [197] = { [1] = X_MOUNT4,    [2] = "YES", [3] = "EXTR" },
     [196] = { [1] = X_MOUNT3,    [2] = "YES", [3] = "EXTR" },
     [195] = { [1] = X_MOUNT2,    [2] = "YES", [3] = "EXTR" },
     [194] = { [1] = X_MOUNT1,    [2] = "YES", [3] = "EXTR" },
     [193] = { [1] = ANY_MOUNT2,  [2] = "ANY", [3] = "ANY"  },
     [192] = { [1] = ANY_MOUNT1,  [2] = "ANY", [3] = "ANY"  },
     [191] = { [1] = F_F_MOUNT44, [2] = "YES", [3] = "FAST" },
     [190] = { [1] = F_F_MOUNT43, [2] = "YES", [3] = "FAST" },
     [189] = { [1] = F_F_MOUNT42, [2] = "YES", [3] = "FAST" },
     [188] = { [1] = F_F_MOUNT41, [2] = "YES", [3] = "FAST" },
     [187] = { [1] = F_F_MOUNT40, [2] = "YES", [3] = "FAST" },
     [186] = { [1] = F_F_MOUNT39, [2] = "YES", [3] = "FAST" },
     [185] = { [1] = F_F_MOUNT38, [2] = "YES", [3] = "FAST" },
     [184] = { [1] = F_F_MOUNT37, [2] = "YES", [3] = "FAST" },
     [183] = { [1] = F_F_MOUNT36, [2] = "YES", [3] = "FAST" },
     [182] = { [1] = F_F_MOUNT35, [2] = "YES", [3] = "FAST" },
     [181] = { [1] = F_F_MOUNT34, [2] = "YES", [3] = "FAST" },
     [180] = { [1] = F_F_MOUNT33, [2] = "YES", [3] = "FAST" },
     [179] = { [1] = F_F_MOUNT32, [2] = "YES", [3] = "FAST" },
     [178] = { [1] = F_F_MOUNT31, [2] = "YES", [3] = "FAST" },
     [177] = { [1] = F_F_MOUNT30, [2] = "YES", [3] = "FAST" },
     [176] = { [1] = F_F_MOUNT29, [2] = "YES", [3] = "FAST" },
     [175] = { [1] = F_F_MOUNT28, [2] = "YES", [3] = "FAST" },
     [174] = { [1] = F_F_MOUNT27, [2] = "YES", [3] = "FAST" },
     [173] = { [1] = F_F_MOUNT26, [2] = "YES", [3] = "FAST" },
     [172] = { [1] = F_F_MOUNT25, [2] = "YES", [3] = "FAST" },
     [171] = { [1] = F_F_MOUNT24, [2] = "YES", [3] = "FAST" },
     [170] = { [1] = F_F_MOUNT23, [2] = "YES", [3] = "FAST" },
     [169] = { [1] = F_F_MOUNT22, [2] = "YES", [3] = "FAST" },
     [168] = { [1] = F_F_MOUNT21, [2] = "YES", [3] = "FAST" },
     [167] = { [1] = F_F_MOUNT20, [2] = "YES", [3] = "FAST" },
     [166] = { [1] = F_F_MOUNT19, [2] = "YES", [3] = "FAST" },
     [165] = { [1] = F_F_MOUNT18, [2] = "YES", [3] = "FAST" },
     [164] = { [1] = F_F_MOUNT17, [2] = "YES", [3] = "FAST" },
     [163] = { [1] = F_F_MOUNT16, [2] = "YES", [3] = "FAST" },
     [162] = { [1] = F_F_MOUNT15, [2] = "YES", [3] = "FAST" },
     [161] = { [1] = F_F_MOUNT14, [2] = "YES", [3] = "FAST" },
     [160] = { [1] = F_F_MOUNT13, [2] = "YES", [3] = "FAST" },
     [159] = { [1] = F_F_MOUNT12, [2] = "YES", [3] = "FAST" },
     [158] = { [1] = F_F_MOUNT11, [2] = "YES", [3] = "FAST" },
     [157] = { [1] = F_F_MOUNT10, [2] = "YES", [3] = "FAST" },
     [156] = { [1] = F_F_MOUNT9,  [2] = "YES", [3] = "FAST" },
     [155] = { [1] = F_F_MOUNT8,  [2] = "YES", [3] = "FAST" },
     [154] = { [1] = F_F_MOUNT7,  [2] = "YES", [3] = "FAST" },
     [153] = { [1] = F_F_MOUNT6,  [2] = "YES", [3] = "FAST" },
     [152] = { [1] = F_F_MOUNT5,  [2] = "YES", [3] = "FAST" },
     [151] = { [1] = F_F_MOUNT4,  [2] = "YES", [3] = "FAST" },
     [150] = { [1] = F_F_MOUNT3,  [2] = "YES", [3] = "FAST" },
     [149] = { [1] = F_F_MOUNT2,  [2] = "YES", [3] = "FAST" },
     [148] = { [1] = F_F_MOUNT1,  [2] = "YES", [3] = "FAST" },
     [147] = { [1] = F_S_MOUNT11, [2] = "YES", [3] = "SLOW" },
     [146] = { [1] = F_S_MOUNT10, [2] = "YES", [3] = "SLOW" },
     [145] = { [1] = F_S_MOUNT9,  [2] = "YES", [3] = "SLOW" },
     [144] = { [1] = F_S_MOUNT8,  [2] = "YES", [3] = "SLOW" },
     [143] = { [1] = F_S_MOUNT7,  [2] = "YES", [3] = "SLOW" },
     [142] = { [1] = F_S_MOUNT6,  [2] = "YES", [3] = "SLOW" },
     [141] = { [1] = F_S_MOUNT5,  [2] = "YES", [3] = "SLOW" },
     [140] = { [1] = F_S_MOUNT4,  [2] = "YES", [3] = "SLOW" },
     [139] = { [1] = F_S_MOUNT3,  [2] = "YES", [3] = "SLOW" },
     [138] = { [1] = F_S_MOUNT2,  [2] = "YES", [3] = "SLOW" },
     [137] = { [1] = F_S_MOUNT1,  [2] = "YES", [3] = "SLOW" },
     [136] = { [1] = G_F_MOUNT97, [2] =  "NO", [3] = "FAST" },
     [135] = { [1] = G_F_MOUNT96, [2] =  "NO", [3] = "FAST" },
     [134] = { [1] = G_F_MOUNT95, [2] =  "NO", [3] = "FAST" },
     [133] = { [1] = G_F_MOUNT94, [2] =  "NO", [3] = "FAST" },
     [132] = { [1] = G_F_MOUNT93, [2] =  "NO", [3] = "FAST" },
     [131] = { [1] = G_F_MOUNT92, [2] =  "NO", [3] = "FAST" },
     [130] = { [1] = G_F_MOUNT91, [2] =  "NO", [3] = "FAST" },
     [129] = { [1] = G_F_MOUNT90, [2] =  "NO", [3] = "FAST" },
     [128] = { [1] = G_F_MOUNT89, [2] =  "NO", [3] = "FAST" },
     [127] = { [1] = G_F_MOUNT88, [2] =  "NO", [3] = "FAST" },
     [126] = { [1] = G_F_MOUNT87, [2] =  "NO", [3] = "FAST" },
     [125] = { [1] = G_F_MOUNT86, [2] =  "NO", [3] = "FAST" },
     [124] = { [1] = G_F_MOUNT85, [2] =  "NO", [3] = "FAST" },
     [123] = { [1] = G_F_MOUNT84, [2] =  "NO", [3] = "FAST" },
     [122] = { [1] = G_F_MOUNT83, [2] =  "NO", [3] = "FAST" },
     [121] = { [1] = G_F_MOUNT82, [2] =  "NO", [3] = "FAST" },
     [120] = { [1] = G_F_MOUNT81, [2] =  "NO", [3] = "FAST" },
     [119] = { [1] = G_F_MOUNT80, [2] =  "NO", [3] = "FAST" },
     [118] = { [1] = G_F_MOUNT79, [2] =  "NO", [3] = "FAST" },
     [117] = { [1] = G_F_MOUNT78, [2] =  "NO", [3] = "FAST" },
     [116] = { [1] = G_F_MOUNT77, [2] =  "NO", [3] = "FAST" },
     [115] = { [1] = G_F_MOUNT76, [2] =  "NO", [3] = "FAST" },
     [114] = { [1] = G_F_MOUNT75, [2] =  "NO", [3] = "FAST" },
     [113] = { [1] = G_F_MOUNT74, [2] =  "NO", [3] = "FAST" },
     [112] = { [1] = G_F_MOUNT73, [2] =  "NO", [3] = "FAST" },
     [111] = { [1] = G_F_MOUNT72, [2] =  "NO", [3] = "FAST" },
     [110] = { [1] = G_F_MOUNT71, [2] =  "NO", [3] = "FAST" },
     [109] = { [1] = G_F_MOUNT70, [2] =  "NO", [3] = "FAST" },
     [108] = { [1] = G_F_MOUNT69, [2] =  "NO", [3] = "FAST" },
     [107] = { [1] = G_F_MOUNT68, [2] =  "NO", [3] = "FAST" },
     [106] = { [1] = G_F_MOUNT67, [2] =  "NO", [3] = "FAST" },
     [105] = { [1] = G_F_MOUNT66, [2] =  "NO", [3] = "FAST" },
     [104] = { [1] = G_F_MOUNT65, [2] =  "NO", [3] = "FAST" },
     [103] = { [1] = G_F_MOUNT64, [2] =  "NO", [3] = "FAST" },
     [102] = { [1] = G_F_MOUNT63, [2] =  "NO", [3] = "FAST" },
     [101] = { [1] = G_F_MOUNT62, [2] =  "NO", [3] = "FAST" },
     [100] = { [1] = G_F_MOUNT61, [2] =  "NO", [3] = "FAST" },
      [99] = { [1] = G_F_MOUNT60, [2] =  "NO", [3] = "FAST" },
      [98] = { [1] = G_F_MOUNT59, [2] =  "NO", [3] = "FAST" },
      [97] = { [1] = G_F_MOUNT58, [2] =  "NO", [3] = "FAST" },
      [96] = { [1] = G_F_MOUNT57, [2] =  "NO", [3] = "FAST" },
      [95] = { [1] = G_F_MOUNT56, [2] =  "NO", [3] = "FAST" },
      [94] = { [1] = G_F_MOUNT55, [2] =  "NO", [3] = "FAST" },
      [93] = { [1] = G_F_MOUNT54, [2] =  "NO", [3] = "FAST" },
      [92] = { [1] = G_F_MOUNT53, [2] =  "NO", [3] = "FAST" },
      [91] = { [1] = G_F_MOUNT52, [2] =  "NO", [3] = "FAST" },
      [90] = { [1] = G_F_MOUNT51, [2] =  "NO", [3] = "FAST" },
      [89] = { [1] = G_F_MOUNT50, [2] =  "NO", [3] = "FAST" },
      [88] = { [1] = G_F_MOUNT49, [2] =  "NO", [3] = "FAST" },
      [87] = { [1] = G_F_MOUNT48, [2] =  "NO", [3] = "FAST" },
      [86] = { [1] = G_F_MOUNT47, [2] =  "NO", [3] = "FAST" },
      [85] = { [1] = G_F_MOUNT46, [2] =  "NO", [3] = "FAST" },
      [84] = { [1] = G_F_MOUNT45, [2] =  "NO", [3] = "FAST" },
      [83] = { [1] = G_F_MOUNT44, [2] =  "NO", [3] = "FAST" },
      [82] = { [1] = G_F_MOUNT43, [2] =  "NO", [3] = "FAST" },
      [81] = { [1] = G_F_MOUNT42, [2] =  "NO", [3] = "FAST" },
      [80] = { [1] = G_F_MOUNT41, [2] =  "NO", [3] = "FAST" },
      [79] = { [1] = G_F_MOUNT40, [2] =  "NO", [3] = "FAST" },
      [78] = { [1] = G_F_MOUNT39, [2] =  "NO", [3] = "FAST" },
      [77] = { [1] = G_F_MOUNT38, [2] =  "NO", [3] = "FAST" },
      [76] = { [1] = G_F_MOUNT37, [2] =  "NO", [3] = "FAST" },
      [75] = { [1] = G_F_MOUNT36, [2] =  "NO", [3] = "FAST" },
      [74] = { [1] = G_F_MOUNT35, [2] =  "NO", [3] = "FAST" },
      [73] = { [1] = G_F_MOUNT34, [2] =  "NO", [3] = "FAST" },
      [72] = { [1] = G_F_MOUNT33, [2] =  "NO", [3] = "FAST" },
      [71] = { [1] = G_F_MOUNT32, [2] =  "NO", [3] = "FAST" },
      [70] = { [1] = G_F_MOUNT31, [2] =  "NO", [3] = "FAST" },
      [69] = { [1] = G_F_MOUNT30, [2] =  "NO", [3] = "FAST" },
      [68] = { [1] = G_F_MOUNT29, [2] =  "NO", [3] = "FAST" },
      [67] = { [1] = G_F_MOUNT28, [2] =  "NO", [3] = "FAST" },
      [66] = { [1] = G_F_MOUNT27, [2] =  "NO", [3] = "FAST" },
      [65] = { [1] = G_F_MOUNT26, [2] =  "NO", [3] = "FAST" },
      [64] = { [1] = G_F_MOUNT25, [2] =  "NO", [3] = "FAST" },
      [63] = { [1] = G_F_MOUNT24, [2] =  "NO", [3] = "FAST" },
      [62] = { [1] = G_F_MOUNT23, [2] =  "NO", [3] = "FAST" },
      [61] = { [1] = G_F_MOUNT22, [2] =  "NO", [3] = "FAST" },
      [60] = { [1] = G_F_MOUNT21, [2] =  "NO", [3] = "FAST" },
      [59] = { [1] = G_F_MOUNT20, [2] =  "NO", [3] = "FAST" },
      [58] = { [1] = G_F_MOUNT19, [2] =  "NO", [3] = "FAST" },
      [57] = { [1] = G_F_MOUNT18, [2] =  "NO", [3] = "FAST" },
      [56] = { [1] = G_F_MOUNT17, [2] =  "NO", [3] = "FAST" },
      [55] = { [1] = G_F_MOUNT16, [2] =  "NO", [3] = "FAST" },
      [54] = { [1] = G_F_MOUNT15, [2] =  "NO", [3] = "FAST" },
      [53] = { [1] = G_F_MOUNT14, [2] =  "NO", [3] = "FAST" },
      [52] = { [1] = G_F_MOUNT13, [2] =  "NO", [3] = "FAST" },
      [51] = { [1] = G_F_MOUNT12, [2] =  "NO", [3] = "FAST" },
      [50] = { [1] = G_F_MOUNT11, [2] =  "NO", [3] = "FAST" },
      [49] = { [1] = G_F_MOUNT10, [2] =  "NO", [3] = "FAST" },
      [48] = { [1] = G_F_MOUNT9,  [2] =  "NO", [3] = "FAST" },
      [47] = { [1] = G_F_MOUNT8,  [2] =  "NO", [3] = "FAST" },
      [46] = { [1] = G_F_MOUNT7,  [2] =  "NO", [3] = "FAST" },
      [45] = { [1] = G_F_MOUNT6,  [2] =  "NO", [3] = "FAST" },
      [44] = { [1] = G_F_MOUNT5,  [2] =  "NO", [3] = "FAST" },
      [43] = { [1] = G_F_MOUNT4,  [2] =  "NO", [3] = "FAST" },
      [42] = { [1] = G_F_MOUNT3,  [2] =  "NO", [3] = "FAST" },
      [41] = { [1] = G_F_MOUNT2,  [2] =  "NO", [3] = "FAST" },
      [40] = { [1] = G_F_MOUNT1,  [2] =  "NO", [3] = "FAST" },
      [39] = { [1] = G_S_MOUNT39, [2] =  "NO", [3] = "SLOW" },
      [38] = { [1] = G_S_MOUNT38, [2] =  "NO", [3] = "SLOW" },
      [37] = { [1] = G_S_MOUNT37, [2] =  "NO", [3] = "SLOW" },
      [36] = { [1] = G_S_MOUNT36, [2] =  "NO", [3] = "SLOW" },
      [35] = { [1] = G_S_MOUNT35, [2] =  "NO", [3] = "SLOW" },
      [34] = { [1] = G_S_MOUNT34, [2] =  "NO", [3] = "SLOW" },
      [33] = { [1] = G_S_MOUNT33, [2] =  "NO", [3] = "SLOW" },
      [32] = { [1] = G_S_MOUNT32, [2] =  "NO", [3] = "SLOW" },
      [31] = { [1] = G_S_MOUNT31, [2] =  "NO", [3] = "SLOW" },
      [30] = { [1] = G_S_MOUNT30, [2] =  "NO", [3] = "SLOW" },
      [29] = { [1] = G_S_MOUNT29, [2] =  "NO", [3] = "SLOW" },
      [28] = { [1] = G_S_MOUNT28, [2] =  "NO", [3] = "SLOW" },
      [27] = { [1] = G_S_MOUNT27, [2] =  "NO", [3] = "SLOW" },
      [26] = { [1] = G_S_MOUNT26, [2] =  "NO", [3] = "SLOW" },
      [25] = { [1] = G_S_MOUNT25, [2] =  "NO", [3] = "SLOW" },
      [24] = { [1] = G_S_MOUNT24, [2] =  "NO", [3] = "SLOW" },
      [23] = { [1] = G_S_MOUNT23, [2] =  "NO", [3] = "SLOW" },
      [22] = { [1] = G_S_MOUNT22, [2] =  "NO", [3] = "SLOW" },
      [21] = { [1] = G_S_MOUNT21, [2] =  "NO", [3] = "SLOW" },
      [20] = { [1] = G_S_MOUNT20, [2] =  "NO", [3] = "SLOW" },
      [19] = { [1] = G_S_MOUNT19, [2] =  "NO", [3] = "SLOW" },
      [18] = { [1] = G_S_MOUNT18, [2] =  "NO", [3] = "SLOW" },
      [17] = { [1] = G_S_MOUNT17, [2] =  "NO", [3] = "SLOW" },
      [16] = { [1] = G_S_MOUNT16, [2] =  "NO", [3] = "SLOW" },
      [15] = { [1] = G_S_MOUNT15, [2] =  "NO", [3] = "SLOW" },
      [14] = { [1] = G_S_MOUNT14, [2] =  "NO", [3] = "SLOW" },
      [13] = { [1] = G_S_MOUNT13, [2] =  "NO", [3] = "SLOW" },
      [12] = { [1] = G_S_MOUNT12, [2] =  "NO", [3] = "SLOW" },
      [11] = { [1] = G_S_MOUNT11, [2] =  "NO", [3] = "SLOW" },
      [10] = { [1] = G_S_MOUNT10, [2] =  "NO", [3] = "SLOW" },
       [9] = { [1] = G_S_MOUNT9,  [2] =  "NO", [3] = "SLOW" },
       [8] = { [1] = G_S_MOUNT8,  [2] =  "NO", [3] = "SLOW" },
       [7] = { [1] = G_S_MOUNT7,  [2] =  "NO", [3] = "SLOW" },
       [6] = { [1] = G_S_MOUNT6,  [2] =  "NO", [3] = "SLOW" },
       [5] = { [1] = G_S_MOUNT5,  [2] =  "NO", [3] = "SLOW" },
       [4] = { [1] = G_S_MOUNT4,  [2] =  "NO", [3] = "SLOW" },
       [3] = { [1] = G_S_MOUNT3,  [2] =  "NO", [3] = "SLOW" },
       [2] = { [1] = G_S_MOUNT2,  [2] =  "NO", [3] = "SLOW" },
       [1] = { [1] = G_S_MOUNT1,  [2] =  "NO", [3] = "SLOW" },
  };
end

function GMMount_Go()
        
--[[  if IsMounted() == 1 then
    --GMMount_Print("Mounted");
  else
    --GMMount_Print("Not Mounted");
  end
]]

  local DisGROUNDMOUNT = GROUNDMOUNT;
  local DisFLYINGMOUNT = FLYINGMOUNT;
  
  local grndMnt = {};
  local flyMnt = {};
  
  local slowland = {};
  local fastland = {};
  local slowfly= {};
  local fastfly = {};
  local extMnt = {};
  local aqMnt = {};
  
  local mNum = 0;
  local aq = "no";
  local extreme = "no";
  local fast = "no";
  local RndNumCnt = 0;
  local FRndNumCnt = 0;
  
  GMMount_GetZoneType();
  
--  mName = "No Mount";
  
  local cnt = GetNumCompanions("MOUNT");
  
  if (MOUNTEDUP == nil) then
	extcnt = 1;
	fastflycnt = 1;
	slowflycnt = 1;
	fastlandcnt = 1;
	slowlandcnt = 1;
	aqcnt = 1;
	
      if (cnt > 0) then
        local Counter = 0;
        for Mslot = 1,cnt,1 do
          _, creatureName = GetCompanionInfo("MOUNT", Mslot);
          if (creatureName) then
            Counter = (Counter + 1);
            for index = 1,table.getn(GMMount_Mounts),1 do
              if (GMMount_Mounts[index][1] == creatureName) then
               --GMMount_Print("Looking at "..creatureName);
                if (GMMount_Mounts[index][2] == "YES") then
                 --GMMount_Print("Found Flying Mount");
		 if (GMMount_Flyable == "YES") then
                  if (GMMount_Mounts[index][3] == "EXTR") then
                    --GMMount_Print("Extreme Speed Mount");
                    if (index ~= mNum) then
                      
		      extMnt[extcnt] = creatureName
		      --GMMount_Print("Adding: "..extMnt[extcnt] .." to Extreme array at slot " ..extcnt );
                      mNum = index;
                      RndNumCnt = RndNumCnt + 1;
		      extcnt = extcnt + 1;
                    end
                  
		  elseif (GMMount_Mounts[index][3] == "FAST") then
		    --GMMount_Print("Fast Speed Mount");
                    if (index ~= mNum) then
                      
		      fastfly[fastflycnt] = creatureName
		      --GMMount_Print("Adding: "..fastfly[fastflycnt] .." to FastFlyer array at slot " ..fastflycnt );
                      mNum = index;
		      fastflycnt = fastflycnt + 1;
		     end
		  else
		  --GMMount_Print("Slow Speed Mount");
                    if (index ~= mNum) then
                      
		      slowfly[slowflycnt] = creatureName
		      --GMMount_Print("Adding: "..slowfly[slowflycnt] .." to Slowflyer array at slot " ..slowflycnt );
                      mNum = index;
		      slowflycnt = slowflycnt + 1;
		  end
                end
		end
		
              elseif (GMMount_Mounts[index][2] == "NO") then
                 --GMMount_Print("Found Ground Mount");
                  if (GMMount_Mounts[index][3] == "FAST") then
		    --GMMount_Print("Fast Speed Mount");
                    if (index ~= mNum) then
                      
		      fastland[fastlandcnt] = creatureName
		      --GMMount_Print("Adding: "..fastland[fastlandcnt] .." to FastLand array at slot " ..fastlandcnt );
                      mNum = index;
		      fastlandcnt = fastlandcnt + 1;
		     end
		  else
		  --GMMount_Print("Slow Speed Mount");
                    if (index ~= mNum) then
                      
		      slowland[slowlandcnt] = creatureName
		     --GMMount_Print("Adding: "..slowland[slowlandcnt] .."  to SlowLand at slot " ..slowlandcnt );
                      mNum = index;
		      slowlandcnt = slowlandcnt + 1;
		  end
                end
	    elseif (GMMount_Mounts[index][2] == "AQ") then
                 --GMMount_Print("Found AQ Mount");
                  if (GMMount_Mounts[index][3] == "AQ") then
                    --GMMount_Print("Yep, AQ mount Mount");
                    if (index ~= mNum) then
                      
		      aqMnt[extcnt] = creatureName
		      --GMMount_Print("Adding: "..aqMnt[aqcnt] .." to AQBugs array at slot " ..aqcnt );
                      mNum = index;
                      RndNumCnt = RndNumCnt + 1;
		      aqcnt = aqcnt + 1;
                    end
		    end
	    end
	  end
        end
      end
    end
    end
    end

    --[[
  if (MOUNTEDUP == nil) then
    if (GMMount_ZoneName == AQ) then
      if (cnt > 0) then
        local Counter = 0;
        for Mslot = 1,cnt,1 do
          _, creatureName = GetCompanionInfo("MOUNT", Mslot);
          if (creatureName) then
            Counter = (Counter + 1);
            for index = 1,table.getn(GMMount_Mounts),1 do
              if (GMMount_Mounts[index][1] == creatureName) then
                if (GMMount_Mounts[index][2] == "AQ") then
                  if (GMMount_Mounts[index][3] == "AQ") then
                    if (index ~= mNum) then
		      grndMnt[RndNumCnt] = creatureName
		      aqMnt[RndNumCnt] = creatureName

                      mNum = index;
                      aq = "yes";
                      RndNumCnt = RndNumCnt + 1;
                    end
                  end
                end
              end
            end
          end
        end
      end
    end
    if (aq == "no") then
      RndNumCnt = 0;
      FRndNumCnt = 0;
      if (cnt > 0) then
        local Counter = 0;
        for Mslot = 1,cnt,1 do
          _, creatureName = GetCompanionInfo("MOUNT", Mslot);
          if (creatureName) then
            Counter = (Counter + 1);
            for index = 1,table.getn(GMMount_Mounts),1 do
              if (GMMount_Mounts[index][1] == creatureName) then
               --GMMount_Print("Looking at "..creatureName);
                if (GMMount_Mounts[index][2] == "YES") then
                 --GMMount_Print("Found Flying Mount");
                  if (GMMount_Mounts[index][3] == "EXTR") then
                    --GMMount_Print("Extreme Speed Mount");
                    if (index ~= mNum) then
                      --
			
		      grndMnt[RndNumCnt] = creatureName
		      --GMMount_Print("Adding: "..grndMnt[RndNumCnt] .." at slot " ..RndNumCnt );
		      extMnt[RndNumCnt] = creatureName

                      mNum = index;
                      RndNumCnt = RndNumCnt + 1;
                    end
                  end
                end
                --GMMount_Print("|cff3399CC2nd PART");
                if (GMMount_Flyable == "YES") then
                  --GMMount_Print("Zone is Flyable");
                  if (GMMount_Mounts[index][2] == "NO") then
                    --GMMount_Print(creatureName.." is NOT Flyable");
                    if (GMMount_Mounts[index][3] == "FAST") then
                     --GMMount_Print("Very Fast Speed Mount");
                    --GMMount_Print("Updating Macro");
                      if (index ~= GmNum) then
                        --GMMount_Print("---Part 3");

		        flyMnt[FRndNumCnt] = creatureName
			--GMMount_Print("Adding: "..flyMnt[FRndNumCnt] );
			
                        GmNum = index;
                        FRndNumCnt = FRndNumCnt + 1;
                      end
                    end
                  end
                end
              end
            end
          end
        end
      end
    end
    
    if (extreme == "no") then
      RndNumCnt = 0;
      FRndNumCnt = 0;
      if (cnt > 0) then
        local Counter = 0;
        for Mslot = 1,cnt,1 do
          _, creatureName = GetCompanionInfo("MOUNT", Mslot);
          if (creatureName) then
            Counter = (Counter + 1);
            for index = 1,table.getn(GMMount_Mounts),1 do
              if (GMMount_Mounts[index][1] == creatureName) then
                if ((GMMount_Mounts[index][2] == GMMount_Flyable) or (GMMount_Mounts[index][2] == "ANY")) then
                  if ((GMMount_Mounts[index][3] == "FAST") or (GMMount_Mounts[index][3] == "ANY")) then
                    if (index ~= mNum) then
                      --GMMount_Print("---Part 4");

                      grndMnt[RndNumCnt] = creatureName
		        --GMMount_Print("Adding: "..grndMnt[RndNumCnt] .." at slot " ..RndNumCnt );
		      
                      mNum = index;
                      fast = "yes";
                      RndNumCnt = RndNumCnt + 1;
                    end
                  end
                end
                if (GMMount_Flyable == "YES") then
                  if (GMMount_Mounts[index][2] == "NO") then
                    if (GMMount_Mounts[index][3] == "FAST") then
                      if (index ~= GmNum) then
                        --GMMount_Print("---Part 5");
 
                       flyMnt[FRndNumCnt] = creatureName
		       --GMMount_Print("Adding: "..flyMnt[FRndNumCnt] );

                        GmNum = index;
                        FRndNumCnt = FRndNumCnt + 1;
                      end
                    end
                  end
                end
              end
            end
          end
        end
      end
    end
    if (fast == "no") then
      RndNumCnt = 0;
      FRndNumCnt = 0;
      if (cnt > 0) then
        local Counter = 0;
        for Mslot = 1,cnt,1 do
          _, creatureName = GetCompanionInfo("MOUNT", Mslot);
          if (creatureName) then
            Counter = (Counter + 1);
            for index = 1,table.getn(GMMount_Mounts),1 do
              if (GMMount_Mounts[index][1] == creatureName) then
                if ((GMMount_Mounts[index][2] == GMMount_Flyable) or (GMMount_Mounts[index][2] == "ANY")) then
                  if ((GMMount_Mounts[index][3] == "SLOW") or (GMMount_Mounts[index][3] == "ANY")) then
                    if (index ~= mNum) then
                      --GMMount_Print("---Part 6");

                       grndMnt[RndNumCnt] = creatureName
		        --GMMount_Print("Adding: "..grndMnt[RndNumCnt] .." at slot " ..RndNumCnt );

                      mNum = index;
                      RndNumCnt = RndNumCnt + 1;
                    end
                  end
                end
              end
            end
          end
        end
      end
    end
  end
  
  
  
  
  
  
  if (RndNumCnt > 0) then
    GndRandNum = math.random(1,RndNumCnt);
    --GMMount_Print("G RndNumCnt = "..RndNumCnt);
    --GMMount_Print("picking = "..GndRandNum);
    --GMMount_Print("found a "..grndMnt[GndRandNum-1]);
    GROUNDMOUNT = grndMnt[GndRandNum-1]
  end
  if (FRndNumCnt > 0) then
    FlyRandNum = math.random(1,FRndNumCnt);
    --GMMount_Print("F RndNumCnt = "..FRndNumCnt);
    FLYINGMOUNT    = flyMnt[FlyRandNum-1]
  end
  ]]
  
    MountLevel = 0
    SLOWLAND = "";
    FASTLAND = "";
    SLOWFLYING = "";
    FASTFLYING = "";
   
  if ( # slowland > 0) then
   MountLevel = 1
    FlyRandNum = math.random(1, #slowland);
    --GMMount_Print("F RndNumCnt = "..FRndNumCnt);
    --GMMount_Print("SLOWLAND = "..slowland[FlyRandNum]);
    SLOWLAND    = slowland[FlyRandNum];
  end
  if ( # fastland > 0) then
   MountLevel = 2
    FlyRandNum = math.random(1, #fastland);
    --GMMount_Print("F RndNumCnt = "..FRndNumCnt);
    --GMMount_Print("FASTLAND = "..fastland[FlyRandNum]);
    FASTLAND    = fastland[FlyRandNum];
  end
  if ( # slowfly > 0) then
   MountLevel = 3
    FlyRandNum = math.random(1, #slowfly);
    --GMMount_Print("F RndNumCnt = "..FRndNumCnt);
    --GMMount_Print("SLOWFLYING = "..slowfly[FlyRandNum]);
    SLOWFLYING    = slowfly[FlyRandNum];
  end
   if ( # fastfly > 0) then
    MountLevel = 4
    FlyRandNum = math.random(1, #fastfly);
    --GMMount_Print("F RndNumCnt = "..FRndNumCnt);
    --GMMount_Print("FASTFLYING = "..fastfly[FlyRandNum]);
    FASTFLYING  = fastfly[FlyRandNum];
  end
  
  --GMMount_Print("FASTLAND: "..FASTLAND);
  --GMMount_Print("SLOWLAND: "..SLOWLAND);
  
  if (FASTLAND == "Thalassian Charger") then
	  --GMMount_Print("CHANGING TO CHARGER");
	  FASTLAND = "Summon Charger";
  end
  if (SLOWLAND == "Thalassian Warhorse") then
	  --GMMount_Print("CHANGING TO Warhorse");
	  SLOWLAND = "Summon Warhorse";
  end
  
  
--EditMacro(GMMount_MACRONAME,GMMount_MACRONAME, 1,"#showtooltip\n/use [button:2,nomounted] hearthstone\n/cast "..GSTWLF..";[button:1, mod:alt,nomod:shift]"..FASTLAND..";[button:1,mod:alt,mod:shift]"..SLOWLAND..";[button:1,mod:shift] "..SLOWFLYING.."; [button:1] "..FASTFLYING.."\n/dismount [button:2 mounted]", nil, nil);
  if (MOUNTEDUP == nil) then
    if (MountLevel == 4) then
       EditMacro(GMMount_MACRONAME,GMMount_MACRONAME, 1,"#showtooltip\n/use [button:2,nomounted] hearthstone\n/cast "..GSTWLF.."[button:1, mod:alt]"..FASTLAND..";[button:1,mod:shift] "..SLOWFLYING.."; [button:1] "..FASTFLYING.."\n/dismount [button:2 mounted]", nil, nil);
    elseif (MountLevel == 3) and (MOUNTEDUP == nil) then
       EditMacro(GMMount_MACRONAME,GMMount_MACRONAME, 1,"#showtooltip\n/use [button:2,nomounted] hearthstone\n/cast "..GSTWLF.."[button:1,mod:alt,nomod:shift]"..FASTLAND..";;[button:1,mod:alt,mod:shift]"..SLOWLAND..";[button:1] "..SLOWFLYING.."\n/dismount [button:2 mounted]", nil, nil);
    elseif (MountLevel == 2) and (MOUNTEDUP == nil) then
       EditMacro(GMMount_MACRONAME,GMMount_MACRONAME, 1,"#showtooltip\n/use [button:2,nomounted] hearthstone\n/cast "..GSTWLF.."[button:1,mod:shift] "..SLOWLAND.."; [button:1] "..FASTLAND.."\n/dismount [button:2mounted]", nil, nil);
    elseif (MountLevel == 1) and (MOUNTEDUP == nil) then
       EditMacro(GMMount_MACRONAME,GMMount_MACRONAME, 1,"#showtooltip\n/use [button:2,nomounted] hearthstone\n/cast "..GSTWLF.."[button:1] "..SLOWLAND.."\n/dismount [button:2mounted]", nil, nil);
    else
       EditMacro(GMMount_MACRONAME,GMMount_MACRONAME, 1,"#showtooltip\n/use [button:2,nomounted] hearthstone\n/cast "..GSTWLF, nil, nil);
    end
  end


end
