﻿--[[
        Give Me Healthstone:
                Copyright 2009 by MERK, Mileg
                based on code by Mileg and Stephen Blaising
                
]]

GMHStone_ADDONNAME = "Give Me Healthstone";
GMHStone_MACRONAME = "GMHStone";

GMHStone_VERSION = "4.2.0";

CONJHS = "";
CONJHS2 = "";

function GMHStone_OnLoad()
  this:RegisterEvent("PLAYER_LOGIN");
  this:RegisterEvent("BAG_UPDATE");

  SlashCmdList["GIVEMEHSTONECOMMAND"] = GMHStone_SlashHandler;
  SLASH_GIVEMEHSTONECOMMAND1 = "/givemehealthstone";
  SLASH_GIVEMEHSTONECOMMAND2 = "/gmhstone";
  SLASH_GIVEMEHSTONECOMMAND3 = "/gmhs";
end

function GMHStone_OnEvent()
  if (event == "PLAYER_LOGIN") then
    if (GetMacroIndexByName(GMHStone_MACRONAME) == 0) then
      local numGenMacros, numCharMacros = GetNumMacros();
      if (numGenMacros < 36) then
        CreateMacro(GMHStone_MACRONAME, 811, "", nil, nil)
      else
        GMHStone_Print("You have 36 General Macros. Cannot add "..GMHStone_MACRONAME.."!");
      end
    end
    if (GetSpellInfo(CHS)) then
      CONJHS = "[button:2] "..CHS.."; ";
      CONJHS2 = "[] "..CHS.."; ";
    else
      CONJHS = "";
    end
GMHStone_MakeArray();
    GMHStone_Go();
  elseif (event == "BAG_UPDATE") then
    GMHStone_MakeArray();
    GMHStone_Go();
  end
end

function GMHStone_SlashHandler(msg)
  if (msg) then
    msg = string.lower(msg);
  end
  if (msg == "help" or msg == "") then
    GMHStone_Print(GMHStone_ADDONNAME.." |cff3399CCv"..GMHStone_VERSION.." ");
    GMHStone_Print("Type /macro to open macro list.");
    GMHStone_Print("Drag GMHStone macro to your action bar.");
    GMHealth_Print("This macro has two purposes.");
    GMHealth_Print("Left click to use best Healthstone.");
    GMHealth_Print("Warlocks can right click to \"Create Healthstone\".");
  end
end

function GMHStone_Print(msg)
  if ((msg) and (strlen(msg) > 0)) then
    if (DEFAULT_CHAT_FRAME) then
      DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 1, 0);
    end
  end
end

function GMHStone_MakeArray()
  GMHStone_Healthstones = {
    [25] = { [1] = HS_5136, [2] = 69 , [3] = 0, [4] = "ALL", [5] = "ALL" },
    [24] = { [1] = HS_4708, [2] = 69 , [3] = 0, [4] = "ALL", [5] = "ALL" },
    [23] = { [1] = HS_4280, [2] = 69 , [3] = 0, [4] = "ALL", [5] = "ALL" },
    [22] = { [1] = HS_4200, [2] = 63 , [3] = 0, [4] = "ALL", [5] = "ALL" },
    [21] = { [1] = HS_3850, [2] = 63 , [3] = 0, [4] = "ALL", [5] = "ALL" },
    [20] = { [1] = HS_3500, [2] = 63 , [3] = 0, [4] = "ALL", [5] = "ALL" },
    [19] = { [1] = HS_2496, [2] = 60 , [3] = 0, [4] = "ALL", [5] = "ALL" },
    [18] = { [1] = HS_2288, [2] = 60 , [3] = 0, [4] = "ALL", [5] = "ALL" },
    [17] = { [1] = HS_2080, [2] = 60 , [3] = 0, [4] = "ALL", [5] = "ALL" },
    [16] = { [1] = HS_2000, [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
    [15] = { [1] = HS_1440, [2] = 48 , [3] = 0, [4] = "ALL", [5] = "ALL" },
    [14] = { [1] = HS_1320, [2] = 48 , [3] = 0, [4] = "ALL", [5] = "ALL" },
    [13] = { [1] = HS_1200, [2] = 48 , [3] = 0, [4] = "ALL", [5] = "ALL" },
    [12] = { [1] = HS_960,  [2] = 36 , [3] = 0, [4] = "ALL", [5] = "ALL" },
    [11] = { [1] = HS_880,  [2] = 36 , [3] = 0, [4] = "ALL", [5] = "ALL" },
    [10] = { [1] = HS_800,  [2] = 36 , [3] = 0, [4] = "ALL", [5] = "ALL" },
    [ 9] = { [1] = HS_600,  [2] = 24 , [3] = 0, [4] = "ALL", [5] = "ALL" },
    [ 8] = { [1] = HS_550,  [2] = 24 , [3] = 0, [4] = "ALL", [5] = "ALL" },
    [ 7] = { [1] = HS_500,  [2] = 24 , [3] = 0, [4] = "ALL", [5] = "ALL" },
    [ 6] = { [1] = HS_300,  [2] = 12 , [3] = 0, [4] = "ALL", [5] = "ALL" },
    [ 5] = { [1] = HS_275,  [2] = 12 , [3] = 0, [4] = "ALL", [5] = "ALL" },
    [ 4] = { [1] = HS_250,  [2] = 12 , [3] = 0, [4] = "ALL", [5] = "ALL" },
    [ 3] = { [1] = HS_120,  [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
    [ 2] = { [1] = HS_110,  [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
    [ 1] = { [1] = HS_100,  [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
  }
end

function GMHStone_Go()
  
  local HStoneRank = 0;
  local HStoneItemNum = 0;
  
  for bagID = 0, 4, 1 do
    local bagSlotCnt = GetContainerNumSlots(bagID);
    if (bagSlotCnt > 0) then
      for slot = 1, bagSlotCnt, 1 do
        local itemLink = GetContainerItemLink(bagID, slot);
        local itemNumber = GMHStone_NumFromLink(itemLink);
        if (itemNumber) then
          for index = 1, table.getn(GMHStone_Healthstones), 1 do
            if (GMHStone_Healthstones[index][1] == itemNumber) then
              if (GMHStone_Healthstones[index][2] <= UnitLevel("player")) then
                if (index > HStoneRank) then    
                  HStoneRank = index;
                  HStoneItemNum = itemNumber;
                end
              end
            end
          end
        end
      end
    end
  end
  
  if (HStoneRank > 0) then
    EditMacro(GMHStone_MACRONAME, GMHStone_MACRONAME, 1, "#showtooltip\n/use "..CONJHS.."item:"..HStoneItemNum, nil, nil);
  elseif (HStoneRank == 0) then
    EditMacro(GMHStone_MACRONAME, GMHStone_MACRONAME, 811, "/use "..CONJHS2, nil, nil);
  end
end

function GMHStone_NumFromLink(itemLink)
  if (not itemLink) then
    return nil;
  end
  local _, _, itemNumber = strfind(itemLink, "item:(%d+):");
  return itemNumber;
end
